package com.vandyo.sentry.core.collectionMachine;

import com.vandyo.sentry.core.dto.ErrStatus;
import org.jetbrains.annotations.NotNull;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.Objects;

public abstract class DataClearDealer implements CollectionDealer {

    @Override
    public String formatData(Map<String, Map<ErrStatus, Long>> data) {
        return formatData(data, null);
    }

    @Override
    public String formatData(@NotNull Map<String, Map<ErrStatus, Long>> data, Map<String, String> names) {
        StringBuilder builder = new StringBuilder();

        builder.append("接口报错：\n");
        for (Map.Entry<String, Map<ErrStatus, Long>> entry : data.entrySet()) {
            builder.append(entry.getKey());
            if (Objects.nonNull(names) && names.containsKey(entry.getKey())) {
                builder.append(" | " + names.get(entry.getKey()));
            }
            builder.append(":\n");
            Map<ErrStatus, Long> value = entry.getValue();
            for (Map.Entry<ErrStatus, Long> i : value.entrySet()) {
                builder.append("    " + i.getKey().getDes() + ":" + i.getValue() + "次。\n");
            }
            builder.append("\n");
        }
        Date d = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        builder.append("\n\n 当前时间： " + sdf.format(d));
        return builder.toString();
    }
}
